searchNodes=[{"doc":"Library to generate and validate CAS TGTs/STs Client usage Generate a tgt and a st for some service: iex&gt; Cassette . tgt { :ok , &quot;TGT-example-abcd&quot; } iex&gt; Cassette . st ( &quot;http://some.authenticated/url&quot; ) { :ok , &quot;ST-example-1234&quot; } Validation usage: iex&gt; st = FakeCas . valid_st iex&gt; Cassette . validate ( st , &quot;http://some.authenticated/url&quot; ) { :ok , Cassette.User . new ( &quot;example&quot; , &quot;customer&quot; , [ &quot;ACME_ADMIN&quot; ] , %{ &quot;cn&quot; =&gt; &quot;John Smith&quot; } ) } Customization and multiple configurations If you need multiple Cassette servers please refer to Cassette.Support for macros that allow to build your own services. Running on development without an actual CAS server The FakeCas module we use for testing is available on :dev as well. To set it up and configure the default Cassette , add to yor dependencies on mix.exs : { :fake_cas , &quot;~&gt; 1.0&quot; } Then initialize it with: iex&gt; FakeCas.Support . initialize :ok With the configuration set, Cassette will always return the TGT returned by FakeCas.valid_tgt/0 : iex&gt; tgt = FakeCas . valid_tgt iex&gt; { :ok , ^ tgt } = Cassette . tgt { :ok , &quot;TGT-example-abcd&quot; } Using the stored valid TGT, Casette will always generate the same ST: iex&gt; st = FakeCas . valid_st iex&gt; { :ok , ^ st } = Cassette . st ( &quot;some-service&quot; ) { :ok , &quot;ST-example-1234&quot; } Trying to validate the ST in FakeCas.valid_st/0 will always succeed for any service: iex&gt; st = FakeCas . valid_st iex&gt; { :ok , _ } = Cassette . validate ( st , &quot;some-service&quot; ) { :ok , Cassette.User . new ( &quot;example&quot; , &quot;customer&quot; , [ &quot;ACME_ADMIN&quot; ] , %{ &quot;cn&quot; =&gt; &quot;John Smith&quot; } ) } And trying to validate any other ST will always fail: iex&gt; Cassette . validate ( &quot;any-other-st&quot; , &quot;some-service&quot; ) { :error , &quot;INVALID_SERVICE: ticket &#39;X&#39; is invalid&quot; }","ref":"Cassette.html","title":"Cassette","type":"module"},{"doc":"Generates a child spec for a custom Cassette module for Elixir &lt; 1.5 If you are adding a custom cassette instance, you can add to your supervision tree by using: defmodule MyCas do use Cassette.Support , process_name : :MyCas end children = [ # ... MyCas . child_spec ] Supervisor . start_link ( children , ... )","ref":"Cassette.html#child_spec/0","title":"Cassette.child_spec/0","type":"function"},{"doc":"Elixir 1.5+ compatible child spec. If you are adding a custom cassette instance, you can add to your supervision tree by using: defmodule MyCas do use Cassette.Support , process_name : :MyCas end children = [ # ... MyCas ] Supervisor . start_link ( children , ... )","ref":"Cassette.html#child_spec/1","title":"Cassette.child_spec/1","type":"function"},{"doc":"Returns the configuration used by this Cassette server Will return the default configuration if not provided. Please refer to Cassette.Config.t for details","ref":"Cassette.html#config/0","title":"Cassette.config/0","type":"function"},{"doc":"Generates a Service Ticket for the given service This function retries once when the TGT is expired on the server side.","ref":"Cassette.html#st/2","title":"Cassette.st/2","type":"function"},{"doc":"","ref":"Cassette.html#start/0","title":"Cassette.start/0","type":"function"},{"doc":"Generates a Ticket Granting Ticket","ref":"Cassette.html#tgt/1","title":"Cassette.tgt/1","type":"function"},{"doc":"Validates a given ticket against the given service or the service set in the configuration","ref":"Cassette.html#validate/3","title":"Cassette.validate/3","type":"function"},{"doc":"ST validation functions","ref":"Cassette.Authentication.html","title":"Cassette.Authentication","type":"module"},{"doc":"Extracts the authenticated user from validation response Returns a tuple with: {:ok, Cassette.User.t} on success {:error, String.t} on error where the string is the failure reason returned by the cas server","ref":"Cassette.Authentication.html#handle_response/1","title":"Cassette.Authentication.handle_response/1","type":"function"},{"doc":"Cas Client wrapper functions Generates Ticket Granting Tickets and Service Tickets Also provides helpers for the default options for the client","ref":"Cassette.Client.html","title":"Cassette.Client","type":"module"},{"doc":"Generates a service ticket ticket given the config, a valid tgt and the target service Checkout Cassette.Client.GenerateSt.perform/3 for details on responses","ref":"Cassette.Client.html#st/3","title":"Cassette.Client.st/3","type":"function"},{"doc":"Generates a ticket granting ticket given the config Checkout Cassette.Client.GenerateTgt.perform/1 for details on responses","ref":"Cassette.Client.html#tgt/1","title":"Cassette.Client.tgt/1","type":"function"},{"doc":"Generates CAS Service Ticket","ref":"Cassette.Client.GenerateSt.html","title":"Cassette.Client.GenerateSt","type":"module"},{"doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#delete/3","title":"Cassette.Client.GenerateSt.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#delete!/3","title":"Cassette.Client.GenerateSt.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#get/3","title":"Cassette.Client.GenerateSt.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#get!/3","title":"Cassette.Client.GenerateSt.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#head/3","title":"Cassette.Client.GenerateSt.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#head!/3","title":"Cassette.Client.GenerateSt.head!/3","type":"function"},{"doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#options/3","title":"Cassette.Client.GenerateSt.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#options!/3","title":"Cassette.Client.GenerateSt.options!/3","type":"function"},{"doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#patch/4","title":"Cassette.Client.GenerateSt.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#patch!/4","title":"Cassette.Client.GenerateSt.patch!/4","type":"function"},{"doc":"Do request to cas service to get a service ticket from ticket granting tickets","ref":"Cassette.Client.GenerateSt.html#perform/3","title":"Cassette.Client.GenerateSt.perform/3","type":"function"},{"doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#post/4","title":"Cassette.Client.GenerateSt.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#post!/4","title":"Cassette.Client.GenerateSt.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1 .","ref":"Cassette.Client.GenerateSt.html#process_headers/1","title":"Cassette.Client.GenerateSt.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1 .","ref":"Cassette.Client.GenerateSt.html#process_request_body/1","title":"Cassette.Client.GenerateSt.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1 .","ref":"Cassette.Client.GenerateSt.html#process_request_headers/1","title":"Cassette.Client.GenerateSt.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1 .","ref":"Cassette.Client.GenerateSt.html#process_request_options/1","title":"Cassette.Client.GenerateSt.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1 .","ref":"Cassette.Client.GenerateSt.html#process_request_params/1","title":"Cassette.Client.GenerateSt.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1 .","ref":"Cassette.Client.GenerateSt.html#process_request_url/1","title":"Cassette.Client.GenerateSt.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1 .","ref":"Cassette.Client.GenerateSt.html#process_response/1","title":"Cassette.Client.GenerateSt.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1 .","ref":"Cassette.Client.GenerateSt.html#process_response_body/1","title":"Cassette.Client.GenerateSt.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1 .","ref":"Cassette.Client.GenerateSt.html#process_response_chunk/1","title":"Cassette.Client.GenerateSt.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1 .","ref":"Cassette.Client.GenerateSt.html#process_response_headers/1","title":"Cassette.Client.GenerateSt.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1 .","ref":"Cassette.Client.GenerateSt.html#process_response_status_code/1","title":"Cassette.Client.GenerateSt.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1 .","ref":"Cassette.Client.GenerateSt.html#process_status_code/1","title":"Cassette.Client.GenerateSt.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1 .","ref":"Cassette.Client.GenerateSt.html#process_url/1","title":"Cassette.Client.GenerateSt.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#put/4","title":"Cassette.Client.GenerateSt.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#put!/4","title":"Cassette.Client.GenerateSt.put!/4","type":"function"},{"doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request = % HTTPoison.Request { method : :post , url : &quot;https://my.website.com&quot; , body : &quot;{ \\&quot; foo \\&quot; : 3}&quot; , headers : [ { &quot;Accept&quot; , &quot;application/json&quot; } ] } request ( request )","ref":"Cassette.Client.GenerateSt.html#request/1","title":"Cassette.Client.GenerateSt.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3 , post/4 , put/4 , etc Args: method - HTTP method as an atom ( :get , :head , :post , :put , :delete , etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}] ) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request ( :post , &quot;https://my.website.com&quot; , &quot;{ \\&quot; foo \\&quot; : 3}&quot; , [ { &quot;Accept&quot; , &quot;application/json&quot; } ] )","ref":"Cassette.Client.GenerateSt.html#request/5","title":"Cassette.Client.GenerateSt.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"Cassette.Client.GenerateSt.html#request!/5","title":"Cassette.Client.GenerateSt.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"Cassette.Client.GenerateSt.html#start/0","title":"Cassette.Client.GenerateSt.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse . See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateSt.html#stream_next/1","title":"Cassette.Client.GenerateSt.stream_next/1","type":"function"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:body/0","title":"Cassette.Client.GenerateSt.body/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:headers/0","title":"Cassette.Client.GenerateSt.headers/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:method/0","title":"Cassette.Client.GenerateSt.method/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:options/0","title":"Cassette.Client.GenerateSt.options/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:params/0","title":"Cassette.Client.GenerateSt.params/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:request/0","title":"Cassette.Client.GenerateSt.request/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:result/0","title":"Cassette.Client.GenerateSt.result/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateSt.html#t:url/0","title":"Cassette.Client.GenerateSt.url/0","type":"type"},{"doc":"Generates CAS Ticket Granting Tickets","ref":"Cassette.Client.GenerateTgt.html","title":"Cassette.Client.GenerateTgt","type":"module"},{"doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#delete/3","title":"Cassette.Client.GenerateTgt.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#delete!/3","title":"Cassette.Client.GenerateTgt.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#get/3","title":"Cassette.Client.GenerateTgt.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#get!/3","title":"Cassette.Client.GenerateTgt.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#head/3","title":"Cassette.Client.GenerateTgt.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#head!/3","title":"Cassette.Client.GenerateTgt.head!/3","type":"function"},{"doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#options/3","title":"Cassette.Client.GenerateTgt.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#options!/3","title":"Cassette.Client.GenerateTgt.options!/3","type":"function"},{"doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#patch/4","title":"Cassette.Client.GenerateTgt.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#patch!/4","title":"Cassette.Client.GenerateTgt.patch!/4","type":"function"},{"doc":"Do request to cas service to get a ticket granting tickets from user","ref":"Cassette.Client.GenerateTgt.html#perform/1","title":"Cassette.Client.GenerateTgt.perform/1","type":"function"},{"doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#post/4","title":"Cassette.Client.GenerateTgt.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#post!/4","title":"Cassette.Client.GenerateTgt.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1 .","ref":"Cassette.Client.GenerateTgt.html#process_headers/1","title":"Cassette.Client.GenerateTgt.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1 .","ref":"Cassette.Client.GenerateTgt.html#process_request_body/1","title":"Cassette.Client.GenerateTgt.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1 .","ref":"Cassette.Client.GenerateTgt.html#process_request_headers/1","title":"Cassette.Client.GenerateTgt.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1 .","ref":"Cassette.Client.GenerateTgt.html#process_request_options/1","title":"Cassette.Client.GenerateTgt.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1 .","ref":"Cassette.Client.GenerateTgt.html#process_request_params/1","title":"Cassette.Client.GenerateTgt.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1 .","ref":"Cassette.Client.GenerateTgt.html#process_request_url/1","title":"Cassette.Client.GenerateTgt.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1 .","ref":"Cassette.Client.GenerateTgt.html#process_response/1","title":"Cassette.Client.GenerateTgt.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1 .","ref":"Cassette.Client.GenerateTgt.html#process_response_body/1","title":"Cassette.Client.GenerateTgt.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1 .","ref":"Cassette.Client.GenerateTgt.html#process_response_chunk/1","title":"Cassette.Client.GenerateTgt.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1 .","ref":"Cassette.Client.GenerateTgt.html#process_response_headers/1","title":"Cassette.Client.GenerateTgt.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1 .","ref":"Cassette.Client.GenerateTgt.html#process_response_status_code/1","title":"Cassette.Client.GenerateTgt.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1 .","ref":"Cassette.Client.GenerateTgt.html#process_status_code/1","title":"Cassette.Client.GenerateTgt.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1 .","ref":"Cassette.Client.GenerateTgt.html#process_url/1","title":"Cassette.Client.GenerateTgt.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#put/4","title":"Cassette.Client.GenerateTgt.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#put!/4","title":"Cassette.Client.GenerateTgt.put!/4","type":"function"},{"doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request = % HTTPoison.Request { method : :post , url : &quot;https://my.website.com&quot; , body : &quot;{ \\&quot; foo \\&quot; : 3}&quot; , headers : [ { &quot;Accept&quot; , &quot;application/json&quot; } ] } request ( request )","ref":"Cassette.Client.GenerateTgt.html#request/1","title":"Cassette.Client.GenerateTgt.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3 , post/4 , put/4 , etc Args: method - HTTP method as an atom ( :get , :head , :post , :put , :delete , etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}] ) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request ( :post , &quot;https://my.website.com&quot; , &quot;{ \\&quot; foo \\&quot; : 3}&quot; , [ { &quot;Accept&quot; , &quot;application/json&quot; } ] )","ref":"Cassette.Client.GenerateTgt.html#request/5","title":"Cassette.Client.GenerateTgt.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"Cassette.Client.GenerateTgt.html#request!/5","title":"Cassette.Client.GenerateTgt.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"Cassette.Client.GenerateTgt.html#start/0","title":"Cassette.Client.GenerateTgt.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse . See request!/5 for more detailed information.","ref":"Cassette.Client.GenerateTgt.html#stream_next/1","title":"Cassette.Client.GenerateTgt.stream_next/1","type":"function"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:body/0","title":"Cassette.Client.GenerateTgt.body/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:headers/0","title":"Cassette.Client.GenerateTgt.headers/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:method/0","title":"Cassette.Client.GenerateTgt.method/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:options/0","title":"Cassette.Client.GenerateTgt.options/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:params/0","title":"Cassette.Client.GenerateTgt.params/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:request/0","title":"Cassette.Client.GenerateTgt.request/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:result/0","title":"Cassette.Client.GenerateTgt.result/0","type":"type"},{"doc":"","ref":"Cassette.Client.GenerateTgt.html#t:url/0","title":"Cassette.Client.GenerateTgt.url/0","type":"type"},{"doc":"Validates a CAS Service Ticket","ref":"Cassette.Client.ValidateTicket.html","title":"Cassette.Client.ValidateTicket","type":"module"},{"doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#delete/3","title":"Cassette.Client.ValidateTicket.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#delete!/3","title":"Cassette.Client.ValidateTicket.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#get/3","title":"Cassette.Client.ValidateTicket.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#get!/3","title":"Cassette.Client.ValidateTicket.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#head/3","title":"Cassette.Client.ValidateTicket.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#head!/3","title":"Cassette.Client.ValidateTicket.head!/3","type":"function"},{"doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#options/3","title":"Cassette.Client.ValidateTicket.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#options!/3","title":"Cassette.Client.ValidateTicket.options!/3","type":"function"},{"doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#patch/4","title":"Cassette.Client.ValidateTicket.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#patch!/4","title":"Cassette.Client.ValidateTicket.patch!/4","type":"function"},{"doc":"Do request to cas service to validate a service ticket","ref":"Cassette.Client.ValidateTicket.html#perform/3","title":"Cassette.Client.ValidateTicket.perform/3","type":"function"},{"doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#post/4","title":"Cassette.Client.ValidateTicket.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#post!/4","title":"Cassette.Client.ValidateTicket.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1 .","ref":"Cassette.Client.ValidateTicket.html#process_headers/1","title":"Cassette.Client.ValidateTicket.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1 .","ref":"Cassette.Client.ValidateTicket.html#process_request_body/1","title":"Cassette.Client.ValidateTicket.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1 .","ref":"Cassette.Client.ValidateTicket.html#process_request_headers/1","title":"Cassette.Client.ValidateTicket.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1 .","ref":"Cassette.Client.ValidateTicket.html#process_request_options/1","title":"Cassette.Client.ValidateTicket.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1 .","ref":"Cassette.Client.ValidateTicket.html#process_request_params/1","title":"Cassette.Client.ValidateTicket.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1 .","ref":"Cassette.Client.ValidateTicket.html#process_request_url/1","title":"Cassette.Client.ValidateTicket.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1 .","ref":"Cassette.Client.ValidateTicket.html#process_response/1","title":"Cassette.Client.ValidateTicket.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1 .","ref":"Cassette.Client.ValidateTicket.html#process_response_body/1","title":"Cassette.Client.ValidateTicket.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1 .","ref":"Cassette.Client.ValidateTicket.html#process_response_chunk/1","title":"Cassette.Client.ValidateTicket.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1 .","ref":"Cassette.Client.ValidateTicket.html#process_response_headers/1","title":"Cassette.Client.ValidateTicket.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1 .","ref":"Cassette.Client.ValidateTicket.html#process_response_status_code/1","title":"Cassette.Client.ValidateTicket.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1 .","ref":"Cassette.Client.ValidateTicket.html#process_status_code/1","title":"Cassette.Client.ValidateTicket.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1 .","ref":"Cassette.Client.ValidateTicket.html#process_url/1","title":"Cassette.Client.ValidateTicket.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#put/4","title":"Cassette.Client.ValidateTicket.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#put!/4","title":"Cassette.Client.ValidateTicket.put!/4","type":"function"},{"doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request = % HTTPoison.Request { method : :post , url : &quot;https://my.website.com&quot; , body : &quot;{ \\&quot; foo \\&quot; : 3}&quot; , headers : [ { &quot;Accept&quot; , &quot;application/json&quot; } ] } request ( request )","ref":"Cassette.Client.ValidateTicket.html#request/1","title":"Cassette.Client.ValidateTicket.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3 , post/4 , put/4 , etc Args: method - HTTP method as an atom ( :get , :head , :post , :put , :delete , etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}] ) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request ( :post , &quot;https://my.website.com&quot; , &quot;{ \\&quot; foo \\&quot; : 3}&quot; , [ { &quot;Accept&quot; , &quot;application/json&quot; } ] )","ref":"Cassette.Client.ValidateTicket.html#request/5","title":"Cassette.Client.ValidateTicket.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"Cassette.Client.ValidateTicket.html#request!/5","title":"Cassette.Client.ValidateTicket.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"Cassette.Client.ValidateTicket.html#start/0","title":"Cassette.Client.ValidateTicket.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse . See request!/5 for more detailed information.","ref":"Cassette.Client.ValidateTicket.html#stream_next/1","title":"Cassette.Client.ValidateTicket.stream_next/1","type":"function"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:body/0","title":"Cassette.Client.ValidateTicket.body/0","type":"type"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:headers/0","title":"Cassette.Client.ValidateTicket.headers/0","type":"type"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:method/0","title":"Cassette.Client.ValidateTicket.method/0","type":"type"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:options/0","title":"Cassette.Client.ValidateTicket.options/0","type":"type"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:params/0","title":"Cassette.Client.ValidateTicket.params/0","type":"type"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:request/0","title":"Cassette.Client.ValidateTicket.request/0","type":"type"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:result/0","title":"Cassette.Client.ValidateTicket.result/0","type":"type"},{"doc":"","ref":"Cassette.Client.ValidateTicket.html#t:url/0","title":"Cassette.Client.ValidateTicket.url/0","type":"type"},{"doc":"Struct that represents Cassette configuration","ref":"Cassette.Config.html","title":"Cassette.Config","type":"module"},{"doc":"Returns a configuration based on what is set in application environment and default values Check Cassette.Config.t for key details","ref":"Cassette.Config.html#default/0","title":"Cassette.Config.default/0","type":"function"},{"doc":"Resolves config by fetching environment variables when values are in the form: { :system , &quot;SOME_ENVIRONMENT_VARIABLE&quot; } The value will be fetched from the SOME_ENVIRONMENT_VARIABLE variable. If that variable is nil , the default value in Cassette.Config.t will be used","ref":"Cassette.Config.html#resolve/1","title":"Cassette.Config.resolve/1","type":"function"},{"doc":"The following keys are supported and may be defined in your application env username - the username to authenticate on cas server password - the password to authenticate on cas server base_url - the base url for your CAS server (do not include the login/ ) base_authority - simplifies role checking, please refer to Cassette.User.role?/2 service - the CAS service to use when validating service tickets tgt_ttl - the TGT cache time to live st_ttl - the ST cache time to live validation_ttl - the ST validation cache time to live insecure - boolean to allow connection even with ssl check failures Any of those keys may be set in your Application environment (or the mix config/config.exs ) as: config :cassette , username : &quot;john.doe&quot; Cassette.Server s call the resolve/1 function on this module to resolve any configuration using environment variables. To use an environment variable set the value to {:system, &quot;SOME_ENVIRONMENT_VARIABLE&quot;} . Or in config.exs : config :cassette , username : { :system , &quot;CASSETTE_USERNAME&quot; } ` ` and configure your environment ( provabably in something like ` / etc / default / your_app ` ) : CASSETTE_USERNAME=acme Please check the ` Cassette.Config . default / 0 ` function .","ref":"Cassette.Config.html#t:t/0","title":"Cassette.Config.t/0","type":"type"},{"doc":"The GenServer that maintains the CAS cache in its state","ref":"Cassette.Server.html","title":"Cassette.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Cassette.Server.html#child_spec/1","title":"Cassette.Server.child_spec/1","type":"function"},{"doc":"Returns this server's current configuration","ref":"Cassette.Server.html#config/1","title":"Cassette.Server.config/1","type":"function"},{"doc":"Initializes the server with the given configuration","ref":"Cassette.Server.html#init/1","title":"Cassette.Server.init/1","type":"function"},{"doc":"Changes the internal state configuration to config","ref":"Cassette.Server.html#reload/2","title":"Cassette.Server.reload/2","type":"function"},{"doc":"Generates Service Ticket based on the configuration of the server and the given tgt","ref":"Cassette.Server.html#st/4","title":"Cassette.Server.st/4","type":"function"},{"doc":"Generates a Ticket Granting Ticket based on the configuration of the server","ref":"Cassette.Server.html#tgt/2","title":"Cassette.Server.tgt/2","type":"function"},{"doc":"Validates a ticket for the given service","ref":"Cassette.Server.html#validate/4","title":"Cassette.Server.validate/4","type":"function"},{"doc":"Struct to represent the internal state of the Cassette.Server","ref":"Cassette.Server.State.html","title":"Cassette.Server.State","type":"module"},{"doc":"Clears the tgt","ref":"Cassette.Server.State.html#clear_tgt/1","title":"Cassette.Server.State.clear_tgt/1","type":"function"},{"doc":"Removes the given {service, ticket} pair from the state","ref":"Cassette.Server.State.html#delete_validation/2","title":"Cassette.Server.State.delete_validation/2","type":"function"},{"doc":"Updates the st cache for the given service","ref":"Cassette.Server.State.html#put_st/3","title":"Cassette.Server.State.put_st/3","type":"function"},{"doc":"Updates the tgt cache","ref":"Cassette.Server.State.html#put_tgt/3","title":"Cassette.Server.State.put_tgt/3","type":"function"},{"doc":"Updates the validation cache for the given {service, ticket} pair with the returned user","ref":"Cassette.Server.State.html#put_validation/3","title":"Cassette.Server.State.put_validation/3","type":"function"},{"doc":"","ref":"Cassette.Server.State.html#t:st/0","title":"Cassette.Server.State.st/0","type":"type"},{"doc":"","ref":"Cassette.Server.State.html#t:t/0","title":"Cassette.Server.State.t/0","type":"type"},{"doc":"","ref":"Cassette.Server.State.html#t:tgt/0","title":"Cassette.Server.State.tgt/0","type":"type"},{"doc":"","ref":"Cassette.Server.State.html#t:validation/0","title":"Cassette.Server.State.validation/0","type":"type"},{"doc":"This macro module allows you to create your own Cassette service with custom configurations You can customize the (otp) application name with the :process_name key and provide your configuration in the :config key. defmodule MyCas do use Cassette.Support , process_name : :EmployeesCas , config : %{ Cassette.Config . default | base_url : &quot;https://employees-cas.example.org&quot; } end Please refer to Cassette for usage","ref":"Cassette.Support.html","title":"Cassette.Support","type":"module"},{"doc":"","ref":"Cassette.Support.html#t:t/0","title":"Cassette.Support.t/0","type":"type"},{"doc":"This is the struct that represents the user returned by a Validation request","ref":"Cassette.User.html","title":"Cassette.User","type":"module"},{"doc":"See Cassette.User.raw_role?/2 .","ref":"Cassette.User.html#has_raw_role?/2","title":"Cassette.User.has_raw_role?/2","type":"function"},{"doc":"See Cassette.User.role?/2 .","ref":"Cassette.User.html#has_role?/2","title":"Cassette.User.has_role?/2","type":"function"},{"doc":"See Cassette.User.role?/3 .","ref":"Cassette.User.html#has_role?/3","title":"Cassette.User.has_role?/3","type":"function"},{"doc":"Initializes a Cassette.User struct, mapping the list of authorities to it's internal representation","ref":"Cassette.User.html#new/2","title":"Cassette.User.new/2","type":"function"},{"doc":"Initializes a Cassette.User struct, with a type attribute and mapping the list of authorities to it's internal representation","ref":"Cassette.User.html#new/3","title":"Cassette.User.new/3","type":"function"},{"doc":"Initializes a Cassette.User struct, with a type attribute, mapping the list of authorities, and any extra attribute returned by the server","ref":"Cassette.User.html#new/4","title":"Cassette.User.new/4","type":"function"},{"doc":"Tests if the user has the given role . This function does not alter the role when checking against the list of authorities. If your user has the ACME_ADMIN authority the following is true: iex&gt; Cassette.User . raw_role? ( some_user , &quot;ACME_ADMIN&quot; ) true iex&gt; Cassette.User . has_raw_role? ( some_user , &quot;ACME_ADMIN&quot; ) true This function returns false when user is not a Cassette.User.t","ref":"Cassette.User.html#raw_role?/2","title":"Cassette.User.raw_role?/2","type":"function"},{"doc":"Tests if the user has the given role respecting the base_authority set in the default configuration If your base_authority is ACME and the user has the ACME_ADMIN authority, then the following is true: iex&gt; Cassette.User . role? ( some_user , &quot;ADMIN&quot; ) true iex&gt; Cassette.User . has_role? ( some_user , &quot;ADMIN&quot; ) true This function returns false when user is not a Cassette.User.t","ref":"Cassette.User.html#role?/2","title":"Cassette.User.role?/2","type":"function"},{"doc":"Tests if the user has the given role using the base_authority set in the default configuration If you are using custom a Cassette.Support server you can use this function to respect it's base_authority This function returns false when user is not a Cassette.User.t","ref":"Cassette.User.html#role?/3","title":"Cassette.User.role?/3","type":"function"},{"doc":"","ref":"Cassette.User.html#t:t/0","title":"Cassette.User.t/0","type":"type"},{"doc":"Elixir version conditional see version/2 .","ref":"Cassette.Version.html","title":"Cassette.Version","type":"module"},{"doc":"Receives a condition just like Version.requirement() , tests if the current elixir version matches that condition and executes the do block or the else block otherwise. The else block is optional and defaults to doing nothing.","ref":"Cassette.Version.html#version/2","title":"Cassette.Version.version/2","type":"macro"},{"doc":"Cassette support files for FakeCas. Provides convience functions for test and development using a stubbed Cas server.","ref":"FakeCas.Support.html","title":"FakeCas.Support","type":"module"},{"doc":"Returns a modified Cassette.Config.t to use FakeCas settings","ref":"FakeCas.Support.html#config/0","title":"FakeCas.Support.config/0","type":"function"},{"doc":"Configures Cassette env using FakeCas settings","ref":"FakeCas.Support.html#configure_cassette/0","title":"FakeCas.Support.configure_cassette/0","type":"function"},{"doc":"Starts the server and configure Cassette to use it","ref":"FakeCas.Support.html#initialize/0","title":"FakeCas.Support.initialize/0","type":"function"},{"doc":"Cassette Library to generate and validate CAS TGTs/STs","ref":"readme.html","title":"Cassette","type":"extras"},{"doc":"The package can be installed as: Add cassette to your list of dependencies in mix.exs : def deps do [ { :cassette , &quot;~&gt; 1.1&quot; } ] end Ensure cassette is started before your application: def application do [ applications : [ :cassette ] ] end","ref":"readme.html#installation","title":"Cassette - Installation","type":"extras"},{"doc":"The module Cassette includes the functions to generate TGTs and STs This will use the default configuration (in mix.config), please refer to Cassete.Config struct for the available keys (including expiration times). config :cassette , username : &quot;example-user&quot; config :cassette , password : &quot;topsecret&quot; config :cassette , base_url : &quot;https://cas-server.example.org&quot; config :cassette , base_authority : &quot;EXAMPLE&quot; config :cassette , service : &quot;app.example.org&quot; base_authority helps on role validation and service is the default value used by Cassette.validate/2 This default configuration is returned by the Cassette.Config.default function. Any of those values may be configured with a tuple, so configuration can be loaded using environment variables: config :cassette , password : { :system , &quot;SOME_ENVIRONMENT_VARIABLE&quot; } A round trip validation would look like this: $ iex - S mix iex&gt; { :ok , tgt } = Cassette . tgt { :ok , &quot;TGT-11692539-ZIvKZ6TlGUBX5DBgR6egYnVvJeHyJpM2oxApxlsIYEaX2dUd9x&quot; } iex&gt; { :ok , st } = Cassette . st ( Cassette.Config . default . service ) { :ok , &quot;ST-16175889-oqcTdH041YZeeLcQtYCL&quot; } iex&gt; Cassette . validate ( st , Cassette.Config . default . service ) { :ok , % Cassette.User { login : &quot;sampleuser&quot; , authorities : [ &quot;ACME_ADMIN&quot; ... ] } } You are not required to call Cassette.tgt , it will be generated (or re-generated in case of expiration) when creating a ST.","ref":"readme.html#usage-with-the-default-configuration","title":"Cassette - Usage with the default configuration","type":"extras"},{"doc":"If you want to use multiple cas services you can create your own module and use the Cassette.Support macro module, you can define the GenServer name and/or provide a configuration. defmodule MyCas do use Cassette.Support , process_name : :MyCasServer , config : % Cassette.Config { ... } end This other Cas service must be started as well with MyCas.start before it can be used or it may be added to your supervision tree: defmodule YourApp do def start ( _type , _args ) do import Supervisor.Spec , warn : false children = [ # some other apps, MyCas . child_spec ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . started ( children , opts ) end end","ref":"readme.html#multiple-configurations","title":"Cassette - Multiple configurations","type":"extras"},{"doc":"If you really really want to use insecure/self-signed certificates, use a Cassette.Config struct with insecure set to true. You can also define in your mix/config.exs like: use Mix.Config config :cassette , :insecure , true","ref":"readme.html#using-self-signed-servers","title":"Cassette - Using self signed servers","type":"extras"},{"doc":"Check out Contributing guide.","ref":"readme.html#contributing","title":"Cassette - Contributing","type":"extras"},{"doc":"Contributing Fork, then clone the repo: git clone git @github . com :your - username / cassete - elixir . git Fetch the dependencies: $ mix deps . get Make sure the tests pass: $ mix test Make your change. Add tests for your change. Make the tests pass: $ mix test Push to your fork and submit a pull request . Some things that will increase the chance that your pull request is accepted: Write tests. Write a good commit message .","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Copyright 2015-2016 Locaweb Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]